# Generated by rust2rpm 24
%bcond_without check

Name:           espanso
Version:        2.2.2
Release:        %autorelease
Summary:        Cross-platform Text Expander written in Rust

License:        GPL-3.0 AND (Apache-2.0 OR MIT) AND BSD-3-Clause) AND ((MIT OR Apache-2.0) AND Unicode-DFS-2016) AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND Apache-2.0 AND BSD-3-Clause AND (CC0-1.0 OR MIT-0 OR Apache-2.0) AND CC0-1.0 AND ISC AND (MIT OR Apache-2.0 OR Zlib) AND MIT AND MPL-2.0 AND (Unlicense OR MIT) AND Zlib
URL:            https://espanso.org/
VCS:            https://github.com/espanso/espanso
Source:         %vcs/archive/v%{version}/%{name}-%{version}.tar.gz
# cd %%{name}-%%{version}/espanso-migrate/
# cargo vendor
# find vendor -maxdepth 1 -type d -not -wholename "vendor/yaml-rust" -not -wholename "vendor" -exec rm -rf {} \;
# cd ../
# tar Jcvf ../%%{name}-%%{version}-vendor.tar.xz  espanso-migrate/vendor/
Source:         %{name}-%{version}-vendor.tar.xz
# Automatically generated patch to strip foreign dependencies
Patch:          espanso-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
# - Bump opener to 0.6.1
# - Bump enum-as-inner to 0.6.1
# - Bump dialoguer to 0.11.0
# - Bump notify-debouncer-mini to 0.4.1
# - Bump sysinfo to 0.30.13
Patch:          espanso-fix-metadata.diff
# Automatically generated patch to strip foreign dependencies
Patch:          espanso-clipboard-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
# - Bump ordered-float to 4.0
# - Bump indoc to 2.0.5
# - Bump mockall to 0.11.4
Patch:          espanso-config-fix-metadata.diff
# Automatically generated patch to strip foreign dependencies
Patch:          espanso-detect-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
# - Bump smithay-client-toolkit to 0.19.2
Patch:          espanso-detect-fix-metadata.diff
# Manually created patch for downstream crate metadata changes
# - Relax html2text 0.6.0
Patch:          espanso-engine-fix-metadata.diff
# Automatically generated patch to strip foreign dependencies
Patch:          espanso-info-fix-metadata-auto.diff
# Automatically generated patch to strip foreign dependencies
Patch:          espanso-inject-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
# - Bump itertools to 0.13.0
Patch:          espanso-inject-fix-metadata.diff
# Automatically generated patch to strip foreign dependencies
Patch:          espanso-ipc-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
# - Change yaml-rust to yaml-rust-terzi
Patch:          espanso-migrate-fix-metadata.diff
# Manually created patch for downstream crate metadata changes
# - Remove winres
# - Bump zip to 0.6.6
Patch:          espanso-modulo-fix-metadata.diff
# Manually created patch for downstream crate metadata changes
# - Bump zip to 0.6.6
Patch:          espanso-package-fix-metadata.diff
# Manually created patch for downstream crate metadata changes
# - Bump sys-locale to 0.3.2
Patch:          espanso-render-fix-metadata.diff
# Automatically generated patch to strip foreign dependencies
Patch:          espanso-ui-fix-metadata-auto.diff

BuildRequires:  rust-packaging >= 23+
BuildRequires:  wxBase-devel
BuildRequires:  wxGTK-devel
BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xcb)

Requires:       xclip

%global _description %{expand:
Cross-platform Text Expander written in Rust.

A text expander is a program that detects when you type a specific keyword and
replaces it with something else. This is useful in many ways:

 - Save a lot of typing, expanding common sentences.
 - Create system-wide code snippets.
 - Execute custom scripts
 - Use emojis like a pro.}

%description %{_description}

%files
%license LICENSE
%license LICENSE.dependencies
%{_bindir}/espanso

%package     -n %{name}-wayland
Summary:        %{summary}
License:        GPL-3.0 AND (Apache-2.0 OR MIT) AND BSD-3-Clause) AND ((MIT OR Apache-2.0) AND Unicode-DFS-2016) AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND Apache-2.0 AND BSD-3-Clause AND (CC0-1.0 OR MIT-0 OR Apache-2.0) AND CC0-1.0 AND ISC AND (MIT OR Apache-2.0 OR Zlib) AND MIT AND MPL-2.0 AND (Unlicense OR MIT) AND Zlib
Requires:       wl-clipboard

%description -n %{name}-wayland
%{_description}

This package contains the Wayland version.

%files       -n %{name}-wayland
%license LICENSE
%license LICENSE.dependencies
%caps(cap_dac_override=pe) %{_bindir}/espanso-wayland

%prep
%autosetup -n %{name}-%{version_no_tilde} -p1 -a1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build -- --package={espanso,espanso-clipboard,espanso-config,espanso-detect,espanso-engine,espanso-info,espanso-inject,espanso-ipc,espanso-kvs,espanso-mac-utils,espanso-match,espanso-migrate,espanso-modulo,espanso-package,espanso-path,espanso-render,espanso-ui} --bin espanso --features="default" --bin espanso-wayland --features="wayland"

%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp target/release/espanso %{buildroot}%{_bindir}/
install -m 0755 -vp target/release/espanso-wayland %{buildroot}%{_bindir}/

%if %{with check}
%check
for f in espanso-clipboard \
    espanso-config \
    espanso-detect \
    espanso-engine \
    espanso-info \
    espanso-inject \
    espanso-kvs \
    espanso-mac-utils \
    espanso-match \
    espanso-migrate \
    espanso-modulo \
    espanso-package \
    espanso-path \
    espanso-render \
    espanso-ui
do
    pushd $f
    %cargo_test
    popd
done
pushd espanso-ipc
%cargo_test -- -- --skip ipc_multiple_clients
popd
%endif

%changelog
%autochangelog
